#include <stdio.h>
#include <stdlib.h>

/** Display a prompt to the user then wait for an integer input. */
int promptValue(const char* prompt) {
    printf("%s:\n", prompt);
    int result;
    scanf("%d", &result);
    return result;
}

/** Linked list of int */
typedef struct link_s {
    int value;
    struct link_s* next;
} link_t;

link_t* list_new(int value) {
    link_t* link_t_new;	
    link_t_new = malloc(sizeof(link_t));
    link_t_new->value = value;
    link_t_new->next = NULL;
    return link_t_new;
}

void list_append(link_t* head, int value) {
	
    while (head->next != NULL) {
    	head = head->next; 
    }
    head->next = list_new(value);
}

unsigned list_count(link_t* head) {
    // And if head is not defined? 
    int count = 1;

    while (head->next != NULL) {
        ++count;
        head = head->next;
    } 
    return count;
}

int list_get(link_t* head, unsigned index) {
    
    if (index < list_count(head)) {
        for (unsigned i = 0; i < index; i++) {
            head = head->next; 
        }
        return head->value;
    } else { 
        return -1;
    }
}

void list_clear(link_t* link) {

    while (link != NULL) {
        link_t* next_link = link->next;
        free(link);
        link = next_link;
    }
}

int main() {
    link_t* head = list_new(1);
    printf("Longueur de la liste: %d\n", list_count(head));
    list_append(head, 2);
    list_append(head, 3);
    list_append(head, 4);
    printf("Longueur de la liste: %d\n", list_count(head));
    printf("Valeur a index %d: %d\n", 2, list_get(head, 2));
    printf("Valeur a index %d: %d\n", 3, list_get(head, 3));
    printf("Valeur a index %d: %d\n", 4, list_get(head, 4));
    list_clear(head);

    return 0;
}
